<!DOCTYPE html>
<html lang="en">

<head>
    <title>Pizza 365 Order Manager</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- font -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

    <!-- Bootstrap -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container">
        <div class="row mt-5 mb-5">
            <div class="col-12 text-center">
                <h4>DANH SÁCH ĐƠN HÀNG</h4>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <table class="table table-bordered table-striped table-hover">
                    <thead>
                        <tr>
                            <th>Mã đơn</th>
                            <th>Combo</th>
                            <th>Pizza</th>
                            <th>Drink</th>
                            <th>Thành tiền</th>
                            <th>Họ và tên</th>
                            <th>Điện thoại</th>
                            <th>Trạng thái</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                    <tbody id="table-body">

                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    var gOrderCode = "";
    var gOrderId = "";
    
    const gEND_TABLE = -1;

    const gCODE_CELL = 0;
    const gCOMBO_CELL = 1;
    const gPIZZA_CELL = 2;
    const gDRINK_CELL = 3;
    const gTOTAL_CELL = 4;
    const gNAME_CELL = 5;
    const gPHONE_CELL = 6;
    const gSTATUS_CELL = 7;
    const gACTION_CELL = 8;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện load trang/F5
    function onPageLoading() {
        // B1: Thu thập dữ liệu
        // B2: Validate dữ liệu
        // B3: Gọi API lấy danh sách đơn hàng
        let vXmlHttpOrderList = new XMLHttpRequest();
        callApiOrderList(vXmlHttpOrderList);
        vXmlHttpOrderList.onreadystatechange = function() {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                // B4: Xử lý hiển thị front-end
                insertOrderListToTable(vXmlHttpOrderList);
            }
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function gọi API lấy danh sách đơn hàng
    function callApiOrderList(paramXmlHttp) {
        paramXmlHttp.open("GET", gBASE_URL, true);
        paramXmlHttp.send();
    }

    // function insert danh sách đơn hàng vào table
    function insertOrderListToTable(paramXmlHttp) {
        // chuyển json string sang object
        let vOrderList = JSON.parse(paramXmlHttp.responseText);
        let vTableBody = document.getElementById("table-body");
        vTableBody.innerHTML = "";
        // đưa data danh sách đơn hàng vào table
        for (let bIndex = 0; bIndex < vOrderList.length; bIndex ++) {
            // thêm dòng mới vào cuối table
            let bNewRow = vTableBody.insertRow(gEND_TABLE);
            // thêm cell tương ứng
            let bCodeCell = bNewRow.insertCell(gCODE_CELL);
            let bComboCell = bNewRow.insertCell(gCOMBO_CELL);
            let bPizzaCell = bNewRow.insertCell(gPIZZA_CELL);
            let bDrinkCell = bNewRow.insertCell(gDRINK_CELL);
            let bTotalCell = bNewRow.insertCell(gTOTAL_CELL);
            let bNameCell = bNewRow.insertCell(gNAME_CELL);
            let bPhoneCell = bNewRow.insertCell(gPHONE_CELL);
            let bStatusCell = bNewRow.insertCell(gSTATUS_CELL);
            let bActionCell = bNewRow.insertCell(gACTION_CELL);
            // gán giá trị cho cell table
            bCodeCell.innerHTML = vOrderList[bIndex].orderCode;
            bComboCell.innerHTML = vOrderList[bIndex].kichCo;
            bPizzaCell.innerHTML = vOrderList[bIndex].loaiPizza;
            bDrinkCell.innerHTML = vOrderList[bIndex].idLoaiNuocUong;
            bTotalCell.innerHTML = vOrderList[bIndex].thanhTien;
            bNameCell.innerHTML = vOrderList[bIndex].hoTen;
            bPhoneCell.innerHTML = vOrderList[bIndex].soDienThoai;
            bStatusCell.innerHTML = vOrderList[bIndex].trangThai;
            // thêm button Chi Tiết vào ô Action
            let bButtonDetail = document.createElement("button");
            bActionCell.appendChild(bButtonDetail);
            bButtonDetail.className = "btn btn-success w-100";
            bButtonDetail.innerHTML = "Chi Tiết";
            bButtonDetail.setAttribute("data-code", vOrderList[bIndex].orderCode);
            bButtonDetail.setAttribute("data-id", vOrderList[bIndex].id);
            bButtonDetail.setAttribute("onclick", "onBtnDetailClick(this)");
        }
    }

</script>

</html>